import React from 'react';
import type { InputProps } from '../input';
import { NativeProps } from '../../utils/native-props';
export declare type VirtualInputProps = {
    onFocus?: () => void;
    onBlur?: () => void;
    onClick?: (e: React.MouseEvent<HTMLDivElement>) => void;
} & Pick<InputProps, 'value' | 'placeholder'> & NativeProps;
export declare type VirtualInputRef = {
    focus: () => void;
    blur: () => void;
};
export declare const VirtualInput: React.ForwardRefExoticComponent<{
    onFocus?: (() => void) | undefined;
    onBlur?: (() => void) | undefined;
    onClick?: ((e: React.MouseEvent<HTMLDivElement>) => void) | undefined;
} & Pick<InputProps, "value" | "placeholder"> & NativeProps<never> & React.RefAttributes<VirtualInputRef>>;
